module.exports = function(grunt) {
    var disclaimer = '/* \n' +
        '* !HTML5 SDK Integration Demo | release <%= grunt.template.today("yyyy-mm-dd") %> \n' +
        '*/ \n\n';

    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),
        watch: {
            options: { livereload: true },
            files: ['./src/**/*.js'],
            tasks: ['concat']
        },
        concat: {
            options: {
                banner: disclaimer
            },
            dist: {
                src: [
                    'lib/*.js',
                    'src/polyfill/*.js',
                    'src/intro.js',
                    'src/utils/*.js',
                    'src/model/*.js',
                    'src/view/*.js',
                    'src/core/*.js',
                    'src/**/*.js',
                    'src/api.js',
                    'src/main.js',
                    'src/outro.js'
                ],
                dest: 'dist/<%= pkg.name %>.js'
            }
        },
        uglify: {
            options: {
                banner: disclaimer,
                mangle: {
                    except: ['error', 'format', 'request', 'model', 'parse', 'core','window','document','console']
                }
            },
            dist: {
                files: {
                    'dist/<%= pkg.name %>-<%= grunt.template.today("yyyymmdd") %>.min.js' : ['<%= concat.dist.dest %>' ]
                }
            }
        }
    });

    require('matchdep').filterDev('grunt-*').forEach(grunt.loadNpmTasks);

    grunt.registerTask('default', 'concat');
    grunt.registerTask('release', ['concat', 'uglify']);
};

