#Overview#

adPlugin.js is an example integration of the Advertising HTML5 SDK (html5-sdk-2.*.min.js) 
located in the 'lib' folder.

#Dependencies#

nodeJS https://nodejs.org
grunt http://gruntjs.com

#Setup#

* install nodeJS https://nodejs.org/download
* install grunt:
	$ npm install -g grunt-cli
* copy all demo files to a local folder
* dowload the latest version of SDK: http://service.videoplaza.tv/proxy/html5-sdk/2/latest/plugin.min.js 
* replace the current version in the 'lib/' folder with the one you download
* open a shell and navigate to the folder root 'demo-html5-2.x/'
* install all grunt dependencies:
	$ npm install
* compile js file:
	$ grunt release
* if works, you should see the compiled .js file with todays date in 'dist/' folder 

#Troubleshoot#

Compile unminified/commented file in 'dist/' folder:
$ grunt

Enable console logging by appending param vplog=true to URL
e.g. http://localhost/demo-html5-2.x/demo/video/index.html?vplog=true

#Release#

Compile uglified file in 'dist/' folder.
$ grunt release

#Test#

Test page: 'demo/video/index.html'

##Desktop##

| Browser 		| OS 		| Result	|
|---------------|-----------|-----------|
| IE 9 			| Win 7		| FAIL 		|
| IE 10			| Win 7		| PASS 		|
| IE 11			| Win 7		| PASS 		|
| Firefox 36	| Mac		| PASS 		|
| Chrome 41		| Mac		| PASS 		|


##Mobile##

| Browser 		| Device		 		| OS 			| Result	|
|---------------|-----------------------|---------------|-----------|
| Chrome 		| Galaxy S3 Phone		| Android 4.3	| PASS 		|
| Chrome		| Nexus 7 Tablet		| Android 4.3 	| PASS 		|
| Safari		| iPhone 5S				| iOS 8.2		| PASS 		|
| Safari		| iPad 4G				| iOS 8.1		| PASS 		|

#Known issues#

* click-through may not work
* post-rolls may not work
* may not show ads/start in some devices
