core.adResponse = (function () {
    'use strict';

    var l = utils.logger;

    function isTimeCapped (insertionPoint) {
        if (insertionPoint.conditions[0].conditions.length > 0) {
            for (var k = 0, len = insertionPoint.conditions[0].conditions.length; k < len; k++) {
                var childCondition = insertionPoint.conditions[0].conditions[k];

                if (childCondition.name === videoplaza.adresponse.PropertyCondition.ConditionName.TIME_SINCE_LINEAR &&
                    childCondition.value > 0) {

                    var timeSinceLinearInMilliseconds = childCondition.value * 1000,
                    	now = new Date().getTime();

                    l.log("adSession", now + " < " + (linearAdLastPlayedTimestamp() + timeSinceLinearInMilliseconds));

                    if (now < linearAdLastPlayedTimestamp() + timeSinceLinearInMilliseconds) {
                        return true;
                    }
                }
            }
        }
    	return false;
    }

    function linearAdLastPlayedTimestamp () {
    	try{
    		var c = document.cookie;
    		return parseInt(c.match(/timeSinceLinear=\d{13}/)[0].substr(16,13));
    	} catch(e) {
    		l.error("could not read cookie property [timeSinceLinear]. Last played time set to 0");
    		return 0;
    	}
    }			

    /* ==========================================================================
    	Public
    ========================================================================== */
    return {
        getAds : function (session, type) {
            l.log("adSession", "start insertion point: " + type);

            var ads = [];
            for (var i = 0, len = session.insertionPoints.length; i < len; i++) {
                var insertionPoint = session.insertionPoints[i];

                // Check to see if this insertion point has the ads we are looking for
                if (insertionPoint.conditions.length === 1 &&
                    insertionPoint.conditions[0].type === type) {

                    // Look for the child condition 'timeSinceLinear' to add support for
                    // time-based frequency capping.
                    var isCapped = isTimeCapped(insertionPoint);
                    l.log("adSession", "is time capped? " + isCapped);

                    if (!isCapped) {
                        for (var j = 0, leng = insertionPoint.slots.length; j < leng; j++) {
                            ads = ads.concat(insertionPoint.slots[j].ads);
                        }
                    }
                }
            }
            return ads;
        }
    };
}());