utils.logger = (function () {
    'use strict';
    
    var isEnabbled = (utils.helpers.queryURI(document.location.search).vplog === 'true');

    function output(type, moduleName, msg, color) {
        if(!isEnabbled) {
            return;
        }

        // I want log a Object
        if (msg === undefined) {
            console.log(moduleName);
            return;
        }
        // Internet Explore
        else if (utils.helpers.isIE()) {
            console.log(type + " [module " + moduleName + "] : " + msg);
        }
        // Chrome, Safari & FF + firebug
        else {
            console.log("%c "+ type +" %c "+ moduleName, "color:#FFFFFF; background:"+ color +";", "color:#000000; background:#C8C8C8;", msg);
        }
    }

    /* ==========================================================================
     Public API
     ========================================================================== */
    return {
        log : function (moduleName, msg, color) {
            output('LOG',moduleName, msg, (color ? color : '#FF33CC'));
        },

        error : function (moduleName, msg, color) {
            output('ERROR',moduleName, msg, (color ? color : '#FF0000'));
        },

        event : function (moduleName, msg, color) {
            output('EVENT',moduleName, msg, (color ? color : '#0066FF'));
        },

        info : function (moduleName, msg, color) {
            output('INFO',moduleName, msg, (color ? color : '#009933'));
        }
    };
}());