view.companionBanner = (function () {
	"use strict";

	var companion,
		l = utils.logger,
		evt = model.events;

	function embedIFrame (divElem, companion) {
		var iframe = "<iframe width='" + companion.width + 
			"' height='" + companion.height + 
			"' src='" + companion.resources[0].url + 
			"' scrolling='no' marginwidth='0' marginheight='0' hspace='0' border='0' frameborder='0'></iframe>";
            divElem.innerHTML = iframe;
	}

	function embedStatic (divElem, companion) {
		var html;
        if (companion.mimeType === "application/x-shockwave-flash") {

            var flashvars = companion.adParameters || "clickTAG=" + encodeURIComponent(companion.clickThroughUrl),
            	id = Math.random();

            html = "<object width='" + companion.width + 
            "' height='" + companion.height + 
            "' id='comp'" + id + 
            "><param name='movie' value=''><param name='flashvars' value='" + flashvars + 
            "'><embed src='" + companion.url + 
            "' width='" + companion.width + 
            "' height='" + companion.height + 
            "' name='comp'" + id + 
            " flashvars='" + flashvars + 
            "' type='application/x-shockwave-flash'></object>";
        } 
        else {
            html = "<a href='" + companion.clickThroughUrl + 
            "' target='_blank' alt=''><img src='" + companionresources[0].url + 
            "' width='" + companion.width + 
            "' height='" + companion.height + 
            "' border='0'></a>";
        }
        divElem.innerHTML = html;
	}

	return {
		show : function (companions) {
			var divElem;

			for (var i = 0, len = companions.length; i < len; i++) {
				companion = companions[i];
				divElem = doc.getElementById(companion.zone);

				l.info('companionBanner', 'companion '+ (i+1) +' id: ' + companion.id);
				l.info('companionBanner', 'companion '+ (i+1) +' div: ' + companion.zone);

				// fail to find companion ID
				if (!divElem) {
					l.error('companionBanner', 'companion div id: '+ companion.zone +' not found');
					return;
				}
				// fail to find companion resource
				if (companion.resources.length === 0) {
					l.error('companionBanner', 'no resources found for companion id: ' + companion.id);
					return;
				}

				var resource = companion.resources[0];

				// embed companion into HTML
				if (resource instanceof videoplaza.adresponse.HtmlResource) {
					divElem.innerHTML = resource.source;
				}
				else if (resource instanceof videoplaza.adresponse.IFrameResource) {
					embedIFrame(divElem, companion);
				}	
				else if (resource instanceof videoplaza.adresponse.StaticResource) {
					embedStatic(divElem, resource);
				}
				doc.dispatchEvent(new CustomEvent(evt.AD_COMPANION_VIEW));
			}
		},
		getCompanion : function () {
			return companion;
		}
	};
}());